#version 330

uniform sampler2D uni_DiffuseMap;

uniform float uni_IntroBlend = 0.7f;
uniform float uni_IntroFadeIn = 0.0f;
uniform float uni_IntroFadeOut = 0.0f;
uniform float uni_IntroWavyness = 0.0f;
uniform float uni_Time = 0.0f;

in vec2 var_TexCoord;

out vec4 frag_Color;

void main(void)
{
	vec2 newCoord = var_TexCoord;
	// **** WAVY LOOKUP
	vec2 offsetAmount = (newCoord.ss) * vec2(0.0,1.0);
	//float offsetAmount = newCoord.s + uni_Time;
	
    vec2 offset = (pow(uni_IntroWavyness,1.2)*0.6) * sin( 15.0f * offsetAmount * pow(uni_IntroWavyness,0.8) );
	newCoord+=offset;	
	
	vec4 texCol = texture(uni_DiffuseMap, newCoord);
	vec4 col = vec4(texCol.rgb * pow(uni_IntroFadeIn,2), texCol.a);
	float gs = col.r *  0.2126 + col.g * 0.7152 + col.b * 0.0722;
	col.a = min(gs * 10.0f,1.0);
	col.a = clamp(col.a + ( 1-uni_IntroBlend),0.0,1.0);
	
	col.a -= pow(uni_IntroFadeOut,4);
	
	//col.a = 0;
	frag_Color = col;
}