#version 330

uniform mat4 uni_InverseViewProjectionMatrix;
uniform vec3 uni_CameraPos;

in vec2 in_2DPosition;

out vec2 var_TexCoord;
out vec3 var_ViewVec;

void main(void)
{
	//get the points of the near plane
	vec4 pers = uni_InverseViewProjectionMatrix * vec4(in_2DPosition,0.0,1.0);
	//world space vector originating from camera and going to near plane corners
	var_ViewVec = pers.xyz / pers.w - uni_CameraPos;

	gl_Position = vec4(in_2DPosition, 0.5, 1.0);
	
	//tex coords from -1 to 1
	var_TexCoord = in_2DPosition;
	//tex coord scaling from 0.0 to 1.0
	//var_TexCoord = in_2DPosition * 0.5 + vec2(0.5,0.5);
}