#version 330

uniform mat4 uni_ViewMatrix;
uniform float uni_Time;

in vec3 in_Vertex;
in float in_Rotation;
in float in_Scale;

out float var_Scale;
out mat2 var_RotationMatrix;

const float amplitudes[4] = float[4](5, 3, 0.003, 0.0008);
const float frequencies[4] = float[4](0.3, -0.12, 14.8, -33.12);
const float phases[4] = float[4](0.0, 0.5, 0.3, 0.2);

// The vertex shader transforms the point into view space
void main(void)
{
	vec4 eyePos = uni_ViewMatrix * vec4(in_Vertex,1);
	
	float offsetAmount = in_Vertex.y + uni_Time;
	for(int i = 0;i<2;++i)
	{
		float offset = amplitudes[i] * sin(frequencies[i] * offsetAmount + phases[i]);
		eyePos.x += offset;
	}
	

	var_RotationMatrix = mat2( cos(in_Rotation), sin(in_Rotation),
							  -sin(in_Rotation), cos(in_Rotation));
	var_Scale = in_Scale;
	
	gl_Position = eyePos;
}