#version 330

uniform sampler2D uni_DiffuseMap;

in vec2 var_TexCoord;
flat in float var_AlphaScale;

out vec4 frag_Color;
out vec4 frag_LSOcclusion;


//simple texture shader, supports blending
void main(void)
{
	vec2 texCoords = var_TexCoord * 0.5 + vec2(0.5,0.5);
	vec3 color = vec3(0.9,0.05,0.02);
	vec3 outerColor = vec3(0.9,0.3,0.03);
	//get color from texture
	float alpha = 1 - texture(uni_DiffuseMap, texCoords).r;
	
	float radius = length(var_TexCoord);
	
	float mixFactor = radius;//; * abs(var_TexCoord.y);
	
	color = mix(outerColor,color,pow(smoothstep(0.0,1.0,mixFactor),0.5));
	
	frag_Color = vec4(color,alpha * var_AlphaScale);
    frag_LSOcclusion = vec4(0,0,0,alpha);
}