#version 330

uniform mat4 uni_ViewMatrix;
uniform float uni_Time;

in vec3 in_Vertex;
in float in_Rotation;
in float in_Scale;

out float var_Scale;
out float var_Rotation;


// The vertex shader transforms the point into view space
void main(void)
{
	vec4 eyePos = uni_ViewMatrix * vec4(in_Vertex,1);	

	var_Rotation = in_Rotation;
	var_Scale = in_Scale;
	
	gl_Position = eyePos;
}