#version 330

uniform mat4 uni_ModelViewProjMatrix;
uniform mat4 uni_ModelViewMatrix;
uniform mat3 uni_NormalMatrix; //matrix to transform normals to VIEW space

in vec3 in_Vertex;
in vec3 in_Normal;
in vec2 in_TexCoord;

out vec2 var_TexCoord;
out vec3 var_Normal;
out vec3 var_EyeVec; //from point to eye

void main(void)
{
	//transform normals
	var_Normal = normalize(uni_NormalMatrix * in_Normal);
	
	vec4 vtx = vec4(in_Vertex,1);
	
	//pos in view space
	vec4 viewPos = uni_ModelViewMatrix * vtx;
	var_EyeVec = normalize(-viewPos.xyz);	
	
	// interpolate tex coords
	var_TexCoord = in_TexCoord;
	
	//final vtx position
	gl_Position =  uni_ModelViewProjMatrix * vtx;
}