#version 330

uniform sampler2D uni_DiffuseMap;

in vec4 var_WorldPosition;
in vec3 var_Normal;

out vec4 frag_Color;

void main(void)
{
   vec3 absNormal = abs(var_Normal);
   vec3 blend_weights = absNormal;
   blend_weights = blend_weights - 0.2679f;
   blend_weights = max(blend_weights, 0);
   
   // force sum to 1.0
   float sum = blend_weights.x + blend_weights.y + blend_weights.z;
   blend_weights = blend_weights.xyz / sum;

   float tex_scale = 0.01f;

   vec2 coord1 = var_WorldPosition.yz * tex_scale;
   vec2 coord2 = var_WorldPosition.zx * tex_scale;
   vec2 coord3 = var_WorldPosition.xy * tex_scale;

   vec4 col1 = texture(uni_DiffuseMap, coord1); 
   vec4 col2 = texture(uni_DiffuseMap, coord2); 
   vec4 col3 = texture(uni_DiffuseMap, coord3);

   //debug colorize - multiply instead of addition
   col1 = col1*vec4(1.0,0.0,0.0,1.0); 
   col2 = col2*vec4(0.0,1.0,0.0,1.0);
   col3 = col3*vec4(0.0,0.0,1.0,1.0);
   
   vec4 blended_color = col1.xyzw * blend_weights.xxxx + 
						col2.xyzw * blend_weights.yyyy + 
						col3.xyzw * blend_weights.zzzz;
					
	blended_color.a = 1.0;

	frag_Color = blended_color;
}