#version 330

//need all 3 mats
uniform mat4 uni_ModelViewProjMatrix;
uniform mat4 uni_ModelViewMatrix;
uniform mat4 uni_ModelMatrix;

uniform mat3 uni_NormalMatrix; //matrix to transform normals to VIEW space

in vec3 in_Vertex;
in vec3 in_Normal;

out vec4 var_WorldPosition;
out vec3 var_Normal; //unmodified normal - used for triplanar texturing
out vec3 var_NormalViewSpace; //transformed normal - used for shading
out vec3 var_EyeVec; //from point to eye

void main(void)
{
	vec4 vtx = vec4(in_Vertex,1);

	//pos in world space
	var_WorldPosition =  uni_ModelMatrix * vtx;
	//pos in view space
	vec4 viewPos = uni_ModelViewMatrix * vtx;

	var_EyeVec = normalize(-viewPos.xyz);

	var_NormalViewSpace = normalize(uni_NormalMatrix * in_Normal);
	var_Normal = in_Normal;

	//final vtx position
	gl_Position = uni_ModelViewProjMatrix * vtx;
}